#include "iostream"
#include "extdate.h"

#include "qstring.h"
#include "qnamespace.h"

#include <qdatetime.h>

void test1_unit(int a_year)
{
	std::cout << "QDate::leapYear( " << a_year << " ) : " << ((QDate::leapYear(a_year)) ? "yes" : "no") << " ; ExtDate::leapYear(.) : " << ((ExtDate::leapYear(a_year)) ? "yes" : "no") << std::endl;
}

void test1()
{
	int	a_set_of_years[] =
	{
		1996,
		1997,
		1998,
		2000,
		1999,
		2001,
		1900,
		1800,
		1700,
		1600,
		2100,
		2200,
		2300,
		0,
		-1,
		-4,
		-100,
		-200,
		-300,
		-400,
		-500
	};
	int	i;
	std::cout << "Date.leapYear()" << std::endl;
	for (i = 0 ; i < sizeof(a_set_of_years)/sizeof(a_set_of_years[0]) ; i++)
	{
		test1_unit(a_set_of_years[i]);
	}
	std::cout << "--------------------" << std::endl;
}

void test2_unit(int y, int m, int d)
{
	QDate	a_date(y, m, d);
	int	a_year;
	int	a_week_number = a_date.weekNumber(&a_year);
	std::cout << "  QDate (" << y << ", " << m << ", " << d << ") : " << a_date.toString() << " ; ";
	std::cout << a_date.day() << "/" << a_date.month() << "/" << a_date.year() ;
	std::cout << " (" << a_date.dayOfWeek() << "/7 ; " << a_date.dayOfYear() << "/365 ; " << a_week_number << "-" << a_year << " )" << std::endl;
	ExtDate	a_ext_date(y, m, d);
	a_week_number = a_ext_date.weekNumber(&a_year);
	std::cout << "ExtDate (" << y << ", " << m << ", " << d << ") : " << a_ext_date.toString() << " ; ";
	std::cout << a_ext_date.day() << "/" << a_ext_date.month() << "/" << a_ext_date.year() ;
	std::cout << " (" << a_ext_date.dayOfWeek() << "/7 ; " << a_ext_date.dayOfYear() << "/365 ; " << a_week_number << "-" << a_year << " )" << std::endl;
}

void test2()
{
	int	a_set_of_dates[][3] = 
	{
		{0, 1, 1},
		{1, 1, 1},
		{2, 1, 1},
		{3, 1, 1},
		{4, 1, 1},
		{5, 1, 1},
		{99, 1, 1},
		{100, 1, 1},
		{100, 12, 31},
		{101, 1, 1},
		{102, 1, 1},
		{103, 1, 1},
		{104, 1, 1},
		{399, 1, 1},
		{400, 1, 1},
		{401, 1, 1},
		{402, 1, 1},
		{403, 1, 1},
		{404, 1, 1},
		{2003, 1, 1},
		{2003, 1, 2},
		{2003, 1, 3},
		{2003, 1, 4},
		{2003, 1, 5},
		{2003, 1, 6},
		{2003, 1, 7},
		{2003, 1, 8},
		{2003, 1, 9},
		{2003, 1, 10},
		{2003, 1, 11},
		{2003, 1, 12},
		{2003, 1, 13},
		{2003, 1, 14},
		{2003, 1, 15},
		{2003, 1, 16},
		{2003, 1, 17},
		{2003, 1, 18},
		{2003, 12, 19},
		{2003, 12, 20},
		{2003, 12, 21},
		{2003, 12, 22},
		{2003, 12, 23},
		{2003, 12, 24},
		{2003, 12, 25},
		{2003, 12, 26},
		{2003, 12, 27},
		{2003, 12, 28},
		{2003, 12, 29},
		{2003, 12, 30},
		{2003, 12, 31},
		{2004, 1, 1},
		{2003, 11, 2}
	};
	int	i;
	std::cout << "Date .day(), .month(), .year(), .dayOfWeek(), .weekNumber()" << std::endl;
	for (i = 0 ; i < sizeof(a_set_of_dates)/sizeof(a_set_of_dates[0]) ; i++)
	{
		test2_unit(a_set_of_dates[i][0], a_set_of_dates[i][1], a_set_of_dates[i][2]);
	}
	std::cout << "--------------------" << std::endl;
}

void test3_unit(int y, int m, int d, int dm)
{
	QDate	a_date(y, m, d);
	ExtDate	a_ext_date(y, m, d);
	QDate	a_date2 = a_date.addMonths(dm);
	ExtDate	a_ext_date2 = a_ext_date.addMonths(dm);
	std::cout << a_date.toString() << " + " << dm << " months -> " << a_ext_date2.toString() << " ; QDate : " << a_date2.toString() << std::endl;
}

void test3()
{
	int	a_set_of_dates_delta[][4] = 
	{
		{2003, 11, 5, 0},
		{2003, 11, 5, 1},
		{2003, 11, 5, -1},
		{2003, 11, 5, 2},
		{2003, 11, 5, 3}
	};
	int	i;
	std::cout << "Date.addMonths()" << std::endl;
	for (i = 0 ; i < sizeof(a_set_of_dates_delta)/sizeof(a_set_of_dates_delta[0]) ; i++)
	{
		test3_unit(a_set_of_dates_delta[i][0], a_set_of_dates_delta[i][1], a_set_of_dates_delta[i][2], a_set_of_dates_delta[i][3]);
	}
	std::cout << "--------------------" << std::endl;
}
void test4_unit(int y, int m, int d, int dy)
{
	QDate	a_date(y, m, d);
	ExtDate	a_ext_date(y, m, d);
	QDate	a_date2 = a_date.addYears(dy);
	ExtDate	a_ext_date2 = a_ext_date.addYears(dy);
	std::cout << d << "/" << m << "/" << y << " + " << dy << " years -> " << a_ext_date2.toString() << " ; QDate : " << a_date2.toString() << std::endl;
}

void test4()
{
	int	a_set_of_dates_delta[][4] = 
	{
		{-1, 11, 5, 0},
		{-1, 11, 5, 1},
		{-1, 11, 5, 2},
		{2003, 11, 5, 1},
		{2003, 11, 5, -1},
		{2003, 11, 5, 2},
		{2003, 11, 5, 3}
	};
	int	i;
	std::cout << "Date.addYears()" << std::endl;
	for (i = 0 ; i < sizeof(a_set_of_dates_delta)/sizeof(a_set_of_dates_delta[0]) ; i++)
	{
		test4_unit(a_set_of_dates_delta[i][0], a_set_of_dates_delta[i][1], a_set_of_dates_delta[i][2], a_set_of_dates_delta[i][3]);
	}
	std::cout << "--------------------" << std::endl;
}

void test5_unit(int y, int m, int d, char *format)
{
	QDate	a_date(y, m, d);
	ExtDate a_ext_date(y, m, d);
	std::cout << "QDate : " << a_date.toString(format) << " ; ExtDate : " << a_ext_date.toString(format) << std::endl;
}

void test5()
{
	char	*a_set_of_formats[] =
	{
		"d.M.yy",
		"dd.MM.yy",
		"ddd.MMM.yy",
		"ddd dd.MMM.yy",
		"dddd.MMMM.yy",
		">dd.M.yyyy<"
	};
	int	i;
	std::cout << "toString(\"...\") " << std::endl;
	for (i = 0 ; i < sizeof(a_set_of_formats)/sizeof(a_set_of_formats[0]) ; i++)
	{
		test5_unit(2003, 11, 5, a_set_of_formats[i]);
	}
	std::cout << "--------------------" << std::endl;
}

void test6_unit(int y, int m, int d)
{
	std::cout << d << "/" << m << "/" << y << " : ExtDate -> " << ExtDate::isValid(y, m, d) << " ; QDate -> " << QDate::isValid(y, m, d) << std::endl;
}

void test6()
{
	int	a_set_of_dates[][3] = 
	{
		{-1, 11, 5},
		{-1, 11, 5},
		{-1, 11, 5},
		{2003, 11, 5},
		{2003, -1, 5},
		{2003, 0, 5},
		{2003, 12, 5},
		{2003, 13, 5},
		{2003, 11, -2},
		{2003, 11, 0},
		{2003, 11, 40},
		{2004, 2, 28},
		{2004, 2, 29},
		{2004, 2, 30},
		{2003, 2, 28},
		{2003, 2, 29},
		{2003, 2, 30}
	};
	int	i;
	std::cout << "Date.isValid()" << std::endl;
	for (i = 0 ; i < sizeof(a_set_of_dates)/sizeof(a_set_of_dates[0]) ; i++)
	{
		test6_unit(a_set_of_dates[i][0], a_set_of_dates[i][1], a_set_of_dates[i][2]);
	}
	std::cout << "--------------------" << std::endl;
}

void test7()
{
	std::cout << "Date::CurrentDate()" << std::endl;
	QDate	a_current_date_local = QDate::currentDate(Qt::LocalTime);
	ExtDate	a_current_date_local_ext = ExtDate::currentDate(Qt::TimeSpec(Qt::LocalTime));
	std::cout << "Qt::LocalTime : Ext -> " << a_current_date_local_ext.toString() << " ; QDate -> " << a_current_date_local.toString() << std::endl;
	QDate	a_current_date_UTC = QDate::currentDate(Qt::UTC);
	ExtDate	a_current_date_UTC_ext = ExtDate::currentDate(Qt::UTC);
	std::cout << "Qt::UTC : Ext -> " << a_current_date_UTC_ext.toString() << " ; QDate -> " << a_current_date_UTC.toString() << std::endl;
	QDate	a_current_date = QDate::currentDate();
	ExtDate	a_current_date_ext = ExtDate::currentDate();
	std::cout << "<default> : Ext -> " << a_current_date_UTC_ext.toString() << " ; QDate -> " << a_current_date_UTC.toString() << std::endl;
	std::cout << "--------------------" << std::endl;
}

int main(int argc, char *argv[])
{
	test1();
	test2();
	test3();
	test4();
	test5();
	test6();
	test7();
	exit(0);
}

